#ifndef NEW_YORK_TRANSIT_LINE_CORE_H
#define NEW_YORK_TRANSIT_LINE_CORE_H

#include "templater.h"
#include <functional>

namespace nytl {
    void parse_bare_file(const std::string& filename, const std::string& content,
        global_elem_set_t& result);
    void parse_special_file(const std::string& filename, const std::string& content,
        global_elem_set_t& result);

    struct LocalVarValue {
        bool is_json = false;
        std::string EL_name;
        const json::JSON* JSON_subval = NULL;
    };

    /* No new JSON object will ever be created, I have one root json argument,
     * all the other json variables are subtrees of it */
    LocalVarValue rendering_core_execute_expression(global_elem_set_t& global_elems,
        const std::vector<LocalVarValue>& local_vars, json::JSON& expr);

    std::string rendering_core(const std::string& entry_func, const std::vector<json::JSON>& entry_arguments,
        std::map<std::string, Element>& elem_ns, const std::function<std::string(std::string)>& escape);
}

#endif
